// nvcc -std=c++11 00_hello_world.cu && ./a.out

#include <iostream>


__device__ char const str[] = "Hello World!";
size_t const str_size = sizeof(str) - 1;


__global__ void hello()
{
	printf("%c\n", str[threadIdx.x % str_size]);
}


int main()
{
	size_t const nb_thread_per_block = str_size;
	size_t const nb_block = 1;
	
	hello<<<nb_block, nb_thread_per_block>>>();
	
	cudaDeviceSynchronize();
	
	return 0;
}
