// nvcc -std=c++11 01_add.cu && ./a.out

#include <iostream>
#include <vector>

#include "hopp/print/std.hpp"


__global__ void add(int * const r, int const * const a, int const * const b)
{
	*r = *a + *b;
}


int main()
{
	// r = a + b
	
	int a = 2;
	int b = 5;
	int r;
	
	int * d_a;
	int * d_b;
	int * d_r;
	
	cudaMalloc(&d_a, sizeof(int));
	cudaMalloc(&d_b, sizeof(int));
	cudaMalloc(&d_r, sizeof(int));
	
	cudaMemcpy(d_a, &a, sizeof(int), cudaMemcpyHostToDevice);
	cudaMemcpy(d_b, &b, sizeof(int), cudaMemcpyHostToDevice);
	
	add<<<1, 1>>>(d_r, d_a, d_b);
	
	cudaMemcpy(&r, d_r, sizeof(int), cudaMemcpyDeviceToHost);
	
	std::cout << "r = " << r << std::endl;
	
	cudaFree(d_a);
	cudaFree(d_b);
	cudaFree(d_r);
	
	return 0;
}
